/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.ow2.util.jmx.api;

import javax.management.MBeanRegistration;
import javax.management.modelmbean.ModelMBean;

/**
 * Extends Commons Modeler BaseModelMBean class to allow adding attributes and operations at runtime.
 * @author missonng
 */
public interface IBaseModelMBeanExt extends ModelMBean, MBeanRegistration {

    /**
     * Add an attribute.
     * @param attribute The attribute to add.
     */
    void addAttribute(final IMBeanAttribute attribute);

    /**
     * Remove an attribute.
     * @param attribute The attribute to remove.
     */
    void removeAttribute(final IMBeanAttribute attribute);

    /**
     * Add an operation.
     * @param operation The operation to add.
     */
    void addOperation(final IMBeanOperation operation);

    /**
     * Remove an operation.
     * @param operation The operation to remove.
     */
    void removeOperation(final IMBeanOperation operation);
}
