/**
 * OW2 Util
 * Copyright (C) 2008 Bull S.A.S.
 * Contact: easybeans@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
 *
 * --------------------------------------------------------------------------
 * $Id$
 * --------------------------------------------------------------------------
 */

package org.ow2.util.jmx.api;

import javax.management.MBeanOperationInfo;

/**
 * Implementations of this interface can be added dynamically as operations in a BaseModelMBeanExt.
 * @author missonng
 */
public interface IMBeanOperation {
    /**
     * Get the MBeanOperationInfo describing this operation.
     * @return The MBeanOperationInfo describing this operation.
     */
    MBeanOperationInfo getMBeanOperationInfo();

    /**
     * Invoke the operation for this BaseModelMBeanExt id.
     * @param id The BaseModelMBeanExt id.
     * @param args The arguments of this operation.
     * @return The result of the invocation.
     */
    Object invoke(String id, Object[] args);
}
